
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*  This code generated by: 
 *      Author : thomas
 *      Date   : Mon Jun 23 2003
 */



#ifndef XMLSCHEMACLASSIFIERCODEDOCUMENT_H
#define XMLSCHEMACLASSIFIERCODEDOCUMENT_H

#include <qstring.h>
#include "../classifiercodedocument.h"
#include "../classifier.h"

class XMLSchemaCodeGenerator;

/**
  * class XMLSchemaClassifierCodeDocument
  * A XMLSchema UMLClassifier Code Document.
  */

class XMLSchemaClassifierCodeDocument : public ClassifierCodeDocument
{
	Q_OBJECT
public:

	// Constructors/Destructors
	//  

	/**
	 * Constructor
	 */
	XMLSchemaClassifierCodeDocument (UMLClassifier * classifier , XMLSchemaCodeGenerator * parent);

	/**
	 * Empty Destructor
	 */
	virtual ~XMLSchemaClassifierCodeDocument ( );

	bool addCodeOperation(CodeOperation *opblock);

        /**
         * create a new CodeAccesorMethod object belonging to this CodeDocument.
         * @return      CodeAccessorMethod
         */
        virtual CodeAccessorMethod * newCodeAccessorMethod( CodeClassField *cf, CodeAccessorMethod::AccessorType type );

       /**
         * create a new CodeOperation object belonging to this CodeDocument.
         * @return      CodeOperation
         */
        virtual CodeOperation * newCodeOperation( UMLOperation * op );

        /**
         * create a new CodeClassField declaration block object belonging to this CodeDocument.
         */
        virtual CodeClassFieldDeclarationBlock * newDeclarationCodeBlock (CodeClassField * cf);

	/**
         * Save the XMI representation of this object
         * @return      bool    status of save
         */
        virtual bool saveToXMI ( QDomDocument & doc, QDomElement & root );

        /**
         * load params from the appropriate XMI element node.
         */
        virtual void loadFromXMI ( QDomElement & root );

protected:


        /** create new code classfield for this document.
         */
        virtual CodeClassField * newCodeClassField( UMLAttribute *at);
        virtual CodeClassField * newCodeClassField( UMLRole *role);

       /** set attributes of the node that represents this class
         * in the XMI document.
         */
        virtual void setAttributesOnNode ( QDomDocument & doc, QDomElement & blockElement);

        /** set the class attributes of this object from
         * the passed element node.
         */
        virtual void setAttributesFromNode ( QDomElement & element);

	bool forceDoc ();
	void updateContent();

private:

	QString fileName; // Just for our convience in creating code
	QString endLine; // characters for ending line. Just for our convience in creating code

	void init ( );


};

#endif // XMLSCHEMACLASSIFIERCODEDOCUMENT_H
